Add casts to remove compiler warnings from native Sun cc.
[deliverable/binutils-gdb.git] / configure
CommitLineData
eb02fd64 1#!/bin/sh
eb02fd64 2
46f3c7cd 3# Configuration script
eb02fd64
RP
4# Copyright (C) 1988, 1990, 1991 Free Software Foundation, Inc.
5
6#This file is part of GNU.
7
063efd10
JG
8# This program is free software; you can redistribute it and/or modify
9# it under the terms of the GNU General Public License as published by
10# the Free Software Foundation; either version 2 of the License, or
11# (at your option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
20# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
eb02fd64 21
74cc5508
RP
22# $Id$
23
49b10446
RP
24# Please email any bugs, comments, and/or additions to this file to:
25# configure@cygnus.com
26
eb02fd64
RP
27#
28# Shell script to create proper links to machine-dependent files in
0df06ca0 29# preparation for compilation.
eb02fd64
RP
30#
31# If configure succeeds, it leaves its status in config.status.
32# If configure fails after disturbing the status quo,
33# config.status is removed.
34#
35
c5ae5678
RP
36export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0 $argv; kill $$)
37
38#set -e
c297d71e 39
eb02fd64
RP
40remove=rm
41hard_link=ln
42symbolic_link='ln -s'
43
44#for Test
45#remove="echo rm"
46#hard_link="echo ln"
47#symbolic_link="echo ln -s"
48
49# clear some things potentially inherited from environment.
6f8ac2d9
RP
50
51Makefile=Makefile
52Makefile_in=Makefile.in
eb02fd64 53ansi=
b8f8fddc 54arguments=$*
6f8ac2d9
RP
55commontargets=
56configdirs=
0df06ca0 57defaulttargets=
ec342d7d 58destdir=
0df06ca0 59fatal=
131a3881 60hostsubdir=
46766962 61norecursion=
49b10446
RP
62objdir=
63objdiroption=
64progname=
46766962 65recurring=
131a3881 66removing=
74cc5508 67srcdir=
ec342d7d 68srctrigger=
131a3881 69target=
0df06ca0 70targets=
131a3881 71targetsubdir=
0df06ca0 72verbose=
eb02fd64
RP
73
74for arg in $*;
75do
ec342d7d 76 case ${arg} in
9fddf5af 77 -ansi | +a*)
eb02fd64 78 ansi=true
bc58b41d 79 clib=clib
eb02fd64 80 ;;
ec342d7d
RP
81 -destdir=* | +destdir=* | +destdi=* | +destd=* | +dest=* | +des=* | +de=* | +d=*)
82 destdir=`echo ${arg} | sed 's/[+-]d[a-z]*=//'`
83 ;;
74cc5508
RP
84 -languages=* | +languages=* | +language=* | +languag=* \
85 | +langua=* | +langu=* | +lang=* | +lan=* | +la=* \
86 | +l=*)
ec342d7d 87 languages="${languages} `echo ${arg} | sed 's/[+-]l[a-z]*=//'`"
eb02fd64 88 ;;
bc58b41d 89 -gas | +g*)
eb02fd64
RP
90 gas=yes
91 ;;
9fddf5af 92 -help | +h*)
0df06ca0
RP
93 fatal=true
94 ;;
9fddf5af 95 -nfp | +nf*)
eb02fd64
RP
96 nfp=yes
97 ;;
46766962
RP
98 -norecursion | +no*)
99 norecursion=true
131a3881 100 ;;
49b10446
RP
101 -objdir=* | +objdir=* | +objdi=* | +objd=* | +obj=* | +ob=* | +o=*)
102 objdiroption=${arg}
103 objdir=`echo ${arg} | sed 's/[+-]o[a-z]*=//'`
104 ;;
46766962
RP
105 -recurring | +recurring | +recurrin | +recurri | +recurr | +recur | +recu | +rec | +re)
106 recurring=true
bc58b41d 107 ;;
46766962 108 -rm | +rm)
ec342d7d 109 removing=${arg}
131a3881 110 ;;
7875b07f
RP
111 -site=* | +site=* | +sit=* | +si=*)
112 site=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
113 ;;
114# -srcdir=* | +srcdir=* | +srcdi=* | +srcd=* | +src=* | +sr=*)
0df06ca0
RP
115# srcdir=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
116# ;;
6f8ac2d9 117 -subdirs | +su*)
991643f5
RP
118 subdirs=${arg}
119 ;;
9fddf5af 120 -target=* | +target=* | +targe=* | +targ=* | +tar=* | +ta=*)
0df06ca0 121 if [ -n "${targets}" ] ; then
991643f5 122 subdirs="+subdirs"
0df06ca0
RP
123 fi
124
125 newtargets="${targets} `echo ${arg} | sed 's/[+-]t[a-z]*=//'`"
126 targets="${newtargets}"
131a3881 127 ;;
49b10446
RP
128 -tmpdir=* | +tmpdir=* | +tmpdi=* | +tmpd=* | +tmp=* | +tm=*)
129 tmpdiroption=${arg}
130 TMPDIR=`echo ${arg} | sed 's/[+-]t[a-z]*=//'`
131 ;;
bc58b41d 132 -v | -verbose | +v*)
0df06ca0
RP
133 verbose=${arg}
134 ;;
135 -* | +*)
136 (echo ;
137 echo "Unrecognized option: \"${arg}\"". ;
138 echo) 1>&2
139 fatal=true
140 ;;
eb02fd64 141 *)
0df06ca0 142 if [ -n "${hosts}" ] ; then
991643f5 143 subdirs="+subdirs"
0df06ca0
RP
144 fi
145
146 newhosts="${hosts} ${arg}"
147 hosts=${newhosts}
eb02fd64
RP
148 ;;
149 esac
150done
151
0df06ca0 152if [ -n "${verbose}" ] ; then
49b10446 153 echo $0 $*
0df06ca0
RP
154fi
155
49b10446
RP
156## this is a little touchy and won't always work, but...
157##
158## if the argv[0] starts with a slash then it is an absolute name that can be
159## used as is.
160##
161## otherwise, if argv[0] has no slash in it, we can assume that it is on the
162## path. Since PATH might include "." we also add `pwd` to the end of PATH.
163##
164## otherwise we prepend `pwd` to $0 and hope that will give us an absolute
165## path.
166##
167
168if (echo $0 | grep '^/' > /dev/null) ; then
169 progname=$0
49b10446
RP
170else
171 if (echo $0 | grep '/' > /dev/null) ; then
172 progname=`pwd`/$0
49b10446
RP
173 else
174 progname=$0
49b10446
RP
175 PATH=$PATH:`pwd` ; export PATH
176 fi
177fi
178
c5ae5678 179configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
bdb73134 180
c5ae5678
RP
181if ${configsub} none >/dev/null 2>&1 ; then
182 true
183else
bdb73134
JW
184 echo '***' cannot find config.sub.
185 echo 1
186fi
49b10446 187
c297d71e
RP
188# process host and target only if not removing.
189if [ -z "${removing}" -a -z "${fatal}" ] ; then
eb02fd64 190 # Complain if an arg is missing
0df06ca0
RP
191 if [ -z "${hosts}" ] ; then
192 (echo ;
193 echo "configure: No HOST specified." ;
bc58b41d 194 echo) 1>&2
0df06ca0 195 fatal=true
eb02fd64 196 fi
131a3881 197fi
eb02fd64 198
0df06ca0
RP
199if [ -n "${fatal}" -o "${hosts}" = "help" ] ; then
200 (echo "Usage: configure HOST" ;
201 echo ;
202 echo "Options: [defaults in brackets]" ;
203 echo " +ansi configure w/ANSI library. [no ansi lib]" ;
49b10446 204 echo " +destdir=MYDIR configure for installation into MYDIR. [\"/usr/local\"]" ;
0df06ca0 205 echo " +gas configure the compilers for use with gas. [native as]" ;
49b10446
RP
206 echo " +help print this message. [normal config]" ;
207 echo " +lang=LANG configure to build LANG. [gcc]" ;
0df06ca0 208 echo " +nfp configure the compilers default to soft floating point. [hard float]" ;
46766962 209 echo " +norecursion configure this directory only. [recurse]" ;
49b10446 210 echo " +objdir=ODIR configure in a parallel tree rooted in ODIR. [rooted in \".\"]" ;
0df06ca0 211 echo " +rm remove this configuration. [build a configuration]" ;
639665de
RP
212 echo " +site configure with site specific makefile" ;
213# This is correctly aligned in the output, even though it isn't here.
214 echo " +subdirs configure in subdirectories. [in source directories]" ;
0df06ca0 215 echo " +target=TARGET configure for TARGET. [TARGET = HOST]" ;
49b10446 216 echo " +tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
0df06ca0
RP
217 echo ;
218 echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
991643f5 219 echo "Asking for more than one \"+target\" implies \"+subdirs\". Any other" ;
0df06ca0
RP
220 echo "options given will apply to all targets.") 1>&2
221
222 if [ -r config.status ] ; then
223 cat config.status
224 fi
225
226 exit 1
eb02fd64
RP
227fi
228
c297d71e
RP
229### break up configure.in.
230if [ -r configure.in ] ; then
231 if [ -z "`grep '^# per\-host:' configure.in`" ] ; then
232 echo '***' `pwd`/configure.in has no "per-host:" line. 1>&2
eb02fd64
RP
233 exit 1
234 fi
235
c297d71e
RP
236 if [ -z "`grep '^# per\-target:' configure.in`" ] ; then
237 echo '***' `pwd`/configure.in has no "per-target:" line. 1>&2
238 exit 1
bc58b41d
RP
239 fi
240
49b10446
RP
241 if [ -z "${TMPDIR}" ] ; then
242 TMPDIR=/tmp ; export TMPDIR
243 fi
244
c5ae5678
RP
245 # keep this filename short for &%*%$*# 14 char file names
246 tmpfile=${TMPDIR}/cONf$$
247
c297d71e
RP
248 # split configure.in into common, per-host, per-target,
249 # and post-target parts. Post-target is optional.
c5ae5678
RP
250 sed -e '/^# per\-host:/,$d' configure.in > ${tmpfile}.com
251 sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' configure.in > ${tmpfile}.hst
252 if grep '^# post-target:' configure.in >/dev/null ; then
253 sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' configure.in > ${tmpfile}.tgt
254 sed -e '1,/^# post\-target:/d' configure.in > ${tmpfile}.pos
c297d71e 255 else
c5ae5678
RP
256 sed -e '1,/^# per\-target:/d' configure.in > ${tmpfile}.tgt
257 echo >${tmpfile}.pos
bc58b41d 258 fi
eb02fd64 259
c297d71e
RP
260else
261 echo '***' No configure.in in `pwd`
262 exit 1
263fi
eb02fd64 264
c297d71e 265### do common part of configure.in
eb02fd64 266
c5ae5678 267. ${tmpfile}.com
eb02fd64 268
ec342d7d 269# some sanity checks on configure.in
0df06ca0 270if [ -z "${srctrigger}" ] ; then
c297d71e 271 echo '***' srctrigger not set in `pwd`/configure.in.
ec342d7d
RP
272 exit 1
273fi
274
0df06ca0
RP
275for host in ${hosts} ; do
276 # Default other arg
277 if [ -z "${targets}" -o -n "${defaulttargets}" ] ; then
278 targets=${host}
279 defaulttargets=true
280 fi
eb02fd64 281
b8f8fddc
RP
282 host_alias=${host}
283
50ac10c1 284 result=`${configsub} ${host}`
bc58b41d
RP
285 host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
286 host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
287 host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
288 host=${host_cpu}-${host_vendor}-${host_os}
ee8f0bd7 289 host_makefile_frag=config/mh-${host}
ba04ec6e
HS
290 if [ ! -f ${host_makefile_frag} ]
291 then
ee8f0bd7 292 host_makefile_frag=config/mh-${host_alias}
ba04ec6e 293 fi
6c18e393 294
c5ae5678 295 . ${tmpfile}.hst
eb02fd64 296
0df06ca0 297 for target in ${targets} ; do
eb02fd64 298
b8f8fddc 299 target_alias=${target}
50ac10c1 300 result=`${configsub} ${target}`
bc58b41d
RP
301 target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
302 target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
303 target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
304 target=${target_cpu}-${target_vendor}-${target_os}
ee8f0bd7 305 target_makefile_frag=config/mt-${target}
ba04ec6e
HS
306 if [ ! -f ${target_makefile_frag} ]
307 then
ee8f0bd7 308 target_makefile_frag=config/mt-${target_alias}
ba04ec6e 309 fi
6408afba 310
c5ae5678 311 . ${tmpfile}.tgt
0df06ca0
RP
312
313 # Temporarily, we support only direct subdir builds.
b8f8fddc
RP
314 hostsubdir=H-${host_alias}
315 targetsubdir=T-${target_alias}
0df06ca0
RP
316
317 if [ -n "${removing}" ] ; then
49b10446
RP
318 if [ -n "${objdir}" ] ; then
319 echo '***' +rm not supported for +objdir. Just \"rm -rf ${objdir}\" by hand.
320 exit 1
321 fi
322
991643f5 323 if [ -n "${subdirs}" ] ; then
67ca110d
RP
324 if [ -d "${hostsubdir}" ] ; then
325 rm -rf ${hostsubdir}/${targetsubdir}
0df06ca0 326
c297d71e 327 if [ -z "`(ls ${hostsubdir}) 2>&1 | grep T- | grep -v T-independent`" ] ; then
67ca110d
RP
328 rm -rf ${hostsubdir}
329 fi
330 else
331 echo Warning: no `pwd`/${hostsubdir} to remove.
0df06ca0
RP
332 fi
333 else
063efd10 334 rm -f ${Makefile} config.status ${links}
0df06ca0 335 fi
74cc5508 336 else
49b10446
RP
337 if [ -n "${objdir}" ]; then
338 srcdir=`pwd`
339 cd ${objdir}
340 fi
341
991643f5 342 if [ -n "${subdirs}" ] ; then
0df06ca0 343 # check for existing status before allowing forced subdirs.
063efd10 344 if [ -f ${Makefile} ] ; then
bc58b41d 345 echo '***' "${Makefile} already exists in source directory. `pwd` not configured." 1>&2
0df06ca0
RP
346 exit 1
347 fi
eb02fd64 348
0df06ca0
RP
349 if [ ! -d ${hostsubdir} ] ; then mkdir ${hostsubdir} ; fi
350 cd ${hostsubdir}
eb02fd64 351
bc58b41d
RP
352 if [ ! -d ${targetsubdir} ] ; then
353 if [ -z "${commontargets}" ] ; then
354 mkdir ${targetsubdir}
355 else
c297d71e
RP
356 if [ ! -d T-independent ] ; then
357 mkdir T-independent
bc58b41d
RP
358 fi
359
c297d71e 360 ${symbolic_link} T-independent ${targetsubdir}
bc58b41d
RP
361 fi # if target independent
362 fi # if no target dir yet
363
0df06ca0 364 cd ${targetsubdir}
eb02fd64 365
49b10446
RP
366 if [ -z "${srcdir}" ] ; then
367 srcdir=../..
368 fi
0df06ca0
RP
369 else
370 # if not subdir builds, then make sure none exist.
c297d71e 371 if [ -n "`(ls .) 2>&1 | (grep H- ; true)`" ] ; then
bc58b41d 372 echo '***' "Configured subdirs exist. `pwd` not configured." 1>&2
0df06ca0 373 exit 1
c297d71e
RP
374 else
375 true
0df06ca0
RP
376 fi
377 fi
eb02fd64 378
0df06ca0
RP
379 # Find the source files, if location was not specified.
380 if [ -z "${srcdir}" ] ; then
381 srcdirdefaulted=1
382 srcdir=.
383 if [ -n "${srctrigger}" -a ! -r ${srctrigger} ] ; then
384 srcdir=..
385 fi
386 fi
eb02fd64 387
0df06ca0
RP
388 if [ -n "${srctrigger}" -a ! -r ${srcdir}/${srctrigger} ] ; then
389 if [ -z "${srcdirdefaulted}" ] ; then
bc58b41d 390 echo '***' "${progname}: Can't find ${srcname} sources in `pwd`/${srcdir}" 1>&2
0df06ca0 391 else
bc58b41d 392 echo '***' "${progname}: Can't find ${srcname} sources in `pwd`/. or `pwd`/.." 1>&2
0df06ca0 393 fi
eb02fd64 394
bc58b41d 395 echo '***' \(At least ${srctrigger} is missing.\) 1>&2
0df06ca0
RP
396 exit 1
397 fi
131a3881 398
0df06ca0
RP
399 # Set up the list of links to be made.
400 # ${links} is the list of link names, and ${files} is the list of names to link to.
eb02fd64 401
0df06ca0
RP
402 # Make the links.
403 while [ -n "${files}" ] ; do
404 # set file to car of files, files to cdr of files
405 set ${files}; file=$1; shift; files=$*
406 set ${links}; link=$1; shift; links=$*
131a3881 407
0df06ca0 408 if [ ! -r ${srcdir}/${file} ] ; then
bc58b41d
RP
409 echo '***' "${progname}: cannot create a link \"${link}\"," 1>&2
410 echo '***' "since the file \"${file}\" does not exist." 1>&2
0df06ca0
RP
411 exit 1
412 fi
131a3881 413
0df06ca0
RP
414 ${remove} -f ${link}
415 rm -f config.status
416 # Make a symlink if possible, otherwise try a hard link
417 ${symbolic_link} ${srcdir}/${file} ${link} 2>/dev/null || ${hard_link} ${srcdir}/${file} ${link}
131a3881 418
0df06ca0 419 if [ ! -r ${link} ] ; then
bc58b41d 420 echo '***' "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
0df06ca0
RP
421 exit 1
422 fi
bc58b41d
RP
423
424 if [ -n "${verbose}" ] ; then
425 echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
426 fi
0df06ca0 427 done
131a3881 428
0df06ca0
RP
429 # Create a .gdbinit file which runs the one in srcdir
430 # and tells GDB to look there for source files.
431
432 case ${srcdir} in
433 .)
434 ;;
435 *)
436 echo "dir ." > .gdbinit
437 echo "dir ${srcdir}" >> .gdbinit
438 echo "source ${srcdir}/.gdbinit" >> .gdbinit
439 ;;
440 esac
441
442 # Install a makefile, and make it set VPATH
443 # if necessary so that the sources are found.
444 # Also change its value of srcdir.
445
446 # FIXME-someday: This business of always writing to .tem and mv back
447 # is so that I don't screw things up while developing. Once this
448 # template is stable, these should be optimized. xoxorich.
449
450 # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
451 if [ "${host}" != "${target}" ] ; then
063efd10
JG
452 echo "CROSS=-DCROSS_COMPILE" > ${Makefile}
453 echo "ALL=start.encap" >> ${Makefile}
0df06ca0 454 else
063efd10 455 echo "ALL=all.internal" > ${Makefile}
0df06ca0 456 fi
131a3881 457
0df06ca0 458 # set target, host, VPATH
b8f8fddc
RP
459 echo "host_alias = ${host_alias}" >> ${Makefile}
460 echo "host_cpu = ${host_cpu}" >> ${Makefile}
461 echo "host_vendor = ${host_vendor}" >> ${Makefile}
462 echo "host_os = ${host_os}" >> ${Makefile}
463
464 echo "target_alias = ${target_alias}" >> ${Makefile}
465 echo "target_cpu = ${target_cpu}" >> ${Makefile}
466 echo "target_vendor = ${target_vendor}" >> ${Makefile}
467 echo "target_os = ${target_os}" >> ${Makefile}
131a3881 468
991643f5 469 if [ -n "${subdirs}" ] ; then
49b10446
RP
470 (echo "subdir = /${hostsubdir}/${targetsubdir}" ;
471 echo "unsubdir = ../..") >> ${Makefile}
0df06ca0 472 else
49b10446
RP
473 (echo "subdir =" ;
474 echo "unsubdir = .") >> ${Makefile}
0df06ca0 475 fi
131a3881 476
063efd10
JG
477 # echo "workdir = `pwd`" >> ${Makefile}
478 echo "VPATH = ${srcdir}" >> ${Makefile}
eb02fd64 479
063efd10
JG
480 # add "Makefile.in" (or whatever it's called)
481 cat ${srcdir}/${Makefile_in} >> ${Makefile}
eb02fd64 482
0df06ca0 483 # Conditionalize the makefile for this host.
ee8f0bd7
SC
484 if [ -f ${srcdir}/${host_makefile_frag} ] ; then
485 (echo "host_makefile_frag = ${srcdir}/${host_makefile_frag}" ;
486 sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile}) > Makefile.tem
487 else
488 (echo "host_makefile_frag =" ;
489 cat ${Makefile}) > Makefile.tem
490 fi
c5ae5678 491 mv Makefile.tem ${Makefile}
131a3881 492
0df06ca0 493 # Conditionalize the makefile for this target.
ee8f0bd7
SC
494 if [ -f ${srcdir}/${target_makefile_frag} ] ; then
495 (echo "target_makefile_frag = ${srcdir}/${target_makefile_frag}" ;
496 sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile}) > Makefile.tem
497 else
498 (echo "target_makefile_frag =" ;
499 cat ${Makefile}) > Makefile.tem
500 fi
c5ae5678 501 mv Makefile.tem ${Makefile}
ec342d7d 502
7875b07f
RP
503 # Conditionalize the makefile for this site.
504 if [ -n "${site}" ] ; then
ee8f0bd7 505 site_makefile_frag=config/ms-${site}
7875b07f 506
ee8f0bd7
SC
507 if [ -f ${srcdir}/${site_makefile_frag} ] ; then
508 (echo "site_makefile_frag = ${srcdir}/${site_makefile_frag}" ;
509 sed -e "/^####/ r ${srcdir}/${site_makefile_frag}" ${Makefile}) > Makefile.tem
510 else
511 (echo "site_makefile_frag =" ;
512 cat ${Makefile}) > Makefile.tem
513 fi
c5ae5678 514 mv Makefile.tem ${Makefile}
7875b07f
RP
515 fi
516
0df06ca0 517 # set srcdir
063efd10
JG
518 sed "s@^srcdir = \.@srcdir = ${srcdir}@" ${Makefile} > Makefile.tem
519 mv Makefile.tem ${Makefile}
eb02fd64 520
0df06ca0
RP
521 # set destdir
522 if [ -n "${destdir}" ] ; then
063efd10
JG
523 sed "s:^destdir =.*$:destdir = ${destdir}:" ${Makefile} > Makefile.tem
524 mv Makefile.tem ${Makefile}
0df06ca0 525 fi
eb02fd64 526
0df06ca0 527 # reset SUBDIRS
063efd10
JG
528 sed "s:^SUBDIRS =.*$:SUBDIRS = ${configdirs}:" ${Makefile} > Makefile.tem
529 mv Makefile.tem ${Makefile}
eb02fd64 530
0df06ca0 531 # reset NONSUBDIRS
063efd10
JG
532 sed "s:^NONSUBDIRS =.*$:NONSUBDIRS = ${noconfigdirs}:" ${Makefile} > Makefile.tem
533 mv Makefile.tem ${Makefile}
eb02fd64 534
7875b07f
RP
535 # remove any form feeds.
536 sed -e "s/\f//" ${Makefile} > Makefile.tem
537 mv Makefile.tem ${Makefile}
538
0df06ca0 539 using=
9d1e053b 540 if [ -f ${srcdir}/${host_makefile_frag} ] ; then
c5ae5678 541 using="${using} and \"${host_makefile_frag}\""
0df06ca0 542 fi
9d1e053b 543 if [ -f ${srcdir}/${target_makefile_frag} ] ; then
c5ae5678 544 using="${using} and \"${target_makefile_frag}\""
0df06ca0 545 fi
c5ae5678
RP
546 if [ -n "${site}" -a \
547 -f ${srcdir}/${site_makefile_frag} ] ; then
548 using="${using} and \"${site_makefile_frag}\""
7875b07f 549 fi
c5ae5678
RP
550 using=`echo "${using}" | sed 's/and/using/'`
551 using="Created \"${Makefile}\" in `pwd`${using}."
7875b07f 552
46766962 553 if [ -n "${verbose}" -o -z "${recurring}" ] ; then
c5ae5678 554 echo ${using}
bc58b41d 555 fi
063efd10 556
c5ae5678 557 . ${tmpfile}.pos
eb02fd64 558
b8f8fddc
RP
559 # describe the chosen configuration in config.status.
560 # Make that file a shellscript which will reestablish
561 # the same configuration. Used in Makefiles to rebuild
562 # Makefiles.
563
564 echo "#!/bin/sh
49b10446 565# `pwd` was configured as follows:
c5ae5678
RP
566(cd ${srcdir} ; ${progname}" ${arguments} `if [ -z "${norecursion}" ] ; then echo +norecursion ; else true ; fi` ")
567# ${using}" > config.status
b8f8fddc 568 chmod a+x config.status
0df06ca0
RP
569
570 originaldir=`pwd`
571 cd ${srcdir}
572 fi
bc58b41d
RP
573
574 # If there are subdirectories, then recurse.
46766962 575 if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
bc58b41d
RP
576 for configdir in ${configdirs} ; do
577 if [ -n "${verbose}" ] ; then
578 echo Configuring ${configdir}...
579 fi
580
581 if [ -d ${configdir} ] ; then
49b10446
RP
582 if [ -n "${objdir}" ] ; then
583 if [ ! -d ${objdir}/${configdir} ] ; then
584 mkdir ${objdir}/${configdir}
585 fi
586 fi
587
5420feaa
RP
588 POPDIR=`pwd`
589 cd ${configdir}
590
c5ae5678 591 if (${progname} +recurring ${host_alias} +target=${target_alias} \
5420feaa
RP
592 ${verbose} ${subdirs} ${removing} +destdir=${destdir} \
593 `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
c5ae5678
RP
594 ${tmpdiroption}) ; then
595 true
596 else
597 exit 1
598 fi
5420feaa
RP
599
600 cd ${POPDIR}
601
602# (cd ${configdir} ;
603# if (${progname} +recurring ${host_alias} +target=${target_alias} \
604# ${verbose} ${subdirs} ${removing} +destdir=${destdir} \
605# `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
606# ${tmpdiroption}) ; then true ; else exit 1 ; fi) \
607# | sed 's/^/ /'
bc58b41d
RP
608 else
609 if [ -n "${verbose}" ] ; then
610 echo Warning: directory \"${configdir}\" is missing.
611 fi
612 fi
613 done
614 fi
67ca110d
RP
615 done # for each target
616
4101d868 617 # Now build a Makefile for this host.
991643f5 618 if [ -n "${subdirs}" -a ! -n "${removing}" ] ; then
49b10446
RP
619 push=`pwd`
620
621 if [ -n "${objdir}" ] ; then
622 cd ${objdir}
623 fi
624
4101d868 625 cd ${hostsubdir}
c5ae5678 626 cat > GNUmakefile << 'E!O!F'
b8f8fddc 627# Makefile generated by configure for host ${host_alias}.
4101d868 628
c297d71e 629ALL := $(shell ls -d T-*)
4101d868
RP
630
631%:
632 $(foreach subdir,$(ALL),$(MAKE) -C $(subdir) \$@ &&) true
633
634all:
635E!O!F
49b10446 636 cd ${push}
4101d868 637 fi
67ca110d 638done # for each host
eb02fd64 639
c297d71e
RP
640### clean up.
641
c5ae5678 642rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos
c297d71e 643
eb02fd64 644exit 0
74cc5508 645
213195dd
RP
646#
647#
648# $Log$
ee8f0bd7
SC
649# Revision 1.63 1991/10/25 02:07:18 steve
650# More name changing
651#
652# Revision 1.62 1991/10/24 11:59:03 rich
653# add null definitions for makefile_frag_foo
654#
655# Revision 1.61 1991/10/24 00:23:59 hgs
ba04ec6e
HS
656# Allow for using tmake-sun4
657#
658# Revision 1.60 1991/10/23 21:48:28 rich
c5ae5678
RP
659# Makefiles should include the makefile frag names even if the makefile
660# frag doesn't exist in *this* directory. Otherwise we inherit the
661# variable setting from our parent Makefile.
662#
663# Revision 1.59 1991/10/16 19:53:31 gnu
664# Update for SCO problems.
665#
666# * Fix "Larry Wall kludge" line so it works. If this script is run by csh,
667# it will complain, feed itself to sh, and complain some more. But will work.
668#
669# * Use <14 char file names in /tmp.
670#
671# Revision 1.58 1991/10/16 06:12:52 rich
672# Two small bugs. First, single quoted sed line doesn't need to quote
673# '$'. Second, use quotes around the hereis document trigger in order
674# to quote the entire contents of the hereis document.
675#
676# Revision 1.57 1991/10/11 05:31:05 gnu
677# Simplify "Using" message code. Put the message that configure prints
678# (or suppresses) into the config.status file as a comment.
679#
680# Revision 1.56 1991/10/10 05:01:47 rich
681# Remove the set -e but protect the recusion call.
682#
683# Revision 1.55 1991/10/10 04:57:23 rich
5420feaa
RP
684# * Die when sub-configure's do.
685# * get the makefile building message line correct.
686# * set -e
687#
688# Revision 1.54 1991/10/10 01:04:42 rich
50ac10c1
RP
689# Backed out the "/bin/sh config.sub" change. Fails when config.sub was
690# on PATH.
691#
692# Revision 1.53 1991/10/10 00:38:08 rich
dafcb8be
RP
693# Call config.sub as "/bin/sh config.sub" instead of directly. This
694# protects us from the case where config.sub isn't executable.
695#
696# Revision 1.52 1991/10/09 00:48:26 rich
639665de
RP
697# Another patch from jim.
698#
699# Revision 1.51 1991/10/08 06:07:58 wilson
bdb73134
JW
700# Fix bug in smake- file code.
701#
702# Revision 1.50 1991/10/04 23:49:37 rich
703# Per's patch for my config.sub botch.
704#
705# Revision 1.49 1991/10/04 22:52:09 rich
49b10446
RP
706# Use john's heuristic for finding ourselves. kinda like hare krishna.
707#
708# Revision 1.48 1991/10/02 13:17:28 rich
709# take out the set -e for now
710#
711# Revision 1.47 1991/10/02 10:02:23 rich
712# * temporary files in TMPDIR
713# * +objdir
714#
715# Revision 1.46 1991/10/02 06:29:53 rich
7875b07f
RP
716# Added +site=foo option for naming site specific Makefile fragments.
717#
718# Revision 1.45 1991/10/02 06:15:13 rich
6f8ac2d9
RP
719# Removed +f option. Used to stand for +forcesubdirs which is now
720# called +subdirs.
721#
722# Revision 1.44 1991/10/02 06:02:35 rich
213195dd
RP
723# Added rcs log line.
724#
725#
726#
727
0df06ca0
RP
728#
729# Local Variables:
730# fill-column: 131
731# End:
732#
74cc5508 733
46f3c7cd 734# end of configure
This page took 0.071373 seconds and 4 git commands to generate.